#include "clipboard.h"

CClipboard::CClipboard()
{
    mMem = NULL;
}

CClipboard::~CClipboard()
{
    clear();
}

void CClipboard::clear()
{
    if (mMem != NULL)
        delete[] mMem;
}

bool CClipboard::isEmpty()
{
    return (mMem == NULL);
}

void CClipboard::copyFromMap(CVec2 pos, CVec2 size)
{
    if (pos.x + size.x > map.mSize.x)
        size.x = map.mSize.x - pos.x;

    if (pos.y + size.y > map.mSize.y)
        size.y = map.mSize.y - pos.y;

    if (size.x == 0 || size.y == 0)
        return;

    clear();
    mSize = size;
    mMem = new CTile[mSize.x * mSize.y];

    if (mMem != NULL)
        for (int y = 0; y < mSize.y; ++y)
            for (int x = 0; x < mSize.x; ++x)
                mMem[y * mSize.x + x] = *map.getTile(CVec2(pos.x + x, pos.y + y));
}

void CClipboard::copyFromClip(CClipboard* src)
{
    clear();

    if (src->isEmpty() == true)
        return;

    mSize = src->mSize;
    mMem = new CTile[mSize.x * mSize.y];

    if (mMem != NULL)
        for (int i = 0; i < mSize.x * mSize.y; ++i)
            mMem[i] = src->mMem[i];
}

void CClipboard::copyToMap(CVec2 pos, ETabIndex index)
{
    for (int y = 0; y < mSize.y; ++y)
        for (int x = 0; x < mSize.x; ++x)
        {
            CTile*  tile = map.getTile(CVec2(pos.x + x, pos.y + y));

            if (tile != NULL)
            {
                if (index == eTabTiles)
                {
                    tile->mType = mMem[y * mSize.x + x].mType;
                }
                else if (index == eTabWalls)
                {
                    for (int i = 0; i < eWallSideMax; ++i)
                        tile->mWalls[i].mType = mMem[y * mSize.x + x].mWalls[i].mType;
                }
            }
        }
}
