#ifndef CEDITOR_H
#define CEDITOR_H

#include "../common/sources/Map.h"
#include "bridge.h"
#include "clipboard.h"
#include <QUndoStack>

#define CURSOR_COLOR    QColor(0, 255, 0)
#define SELECTION_COLOR QColor(0, 255, 255)

class CEditor
{
public:
    CEditor();

    QImage      displayMap(CMap& map, CVec2 mousePos, ETabIndex tabIndex);
    EWallSide   getWallSide(CVec2 localPos);
    EWallSide   getWallSideAbs(CVec2 pos);
    CRect       getSelectionRect();
    QString     getPositionString(CVec2 mousePos, ETabIndex tabIndex);
    void        useTool();
    void        toolCopy();
    void        toolCut();
    void        unselect();
    void        hideSelectionInfos();
    void        initLists();

    QUndoStack* mUndoStack;
    CClipboard  mClipboard;
    CVec2       mSelectStart;
    CVec2       mSelectEnd;

private:
    void        toolDraw();
    void        toolSelect();
    void        toolPaste();
    void        copyData(CRect rect);
};

extern CEditor  editor;

#endif // CEDITOR_H
