﻿#include <QApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>
#include "bridge.h"
#include "keyboard.h"
#include "../common/sources/Map.h"

QQmlContext     *ctxt;

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    QQmlApplicationEngine engine;

    // enregistre nos fonctions
//    ctxt = engine.rootContext();
//    ctxt->setContextProperty("bridge", &bridge);

    // enregistre l'ImageProvider
    engine.addImageProvider("myimageprovider", new MyImageProvider);

    map.load((char *)"maps/test.map");

    // lance l'interface
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));

	// enregistre l'EventFilter pour le clavier
    QApplication::instance()->installEventFilter(&keyboard);

    int retValue = app.exec();

	// désenregistre l'EventFilter
    QApplication::instance()->removeEventFilter(&keyboard);

    return retValue;
}

